
-- NullTrack Checker/Remover
-- by Speed

global nullFounded = 0
global fndNulls = #()
global ptrNulls = #()

rollout NullCheck "Wyszukiwacz i usuwacz NullTrack'w"
(
	group "Wyszukiwacz"
	(
		label labFnd "0 nulltrack(s)"
		button btn_CheckNT "Check" width:200
	)
	group "Usuwacz"
	(
		dropdownlist dlNTList "NullTrack" enabled:false items:#()
		button btn_SelNT "Select" width:50 enabled:false across:3
		button btn_FixNT "Fix Len" width:70 enabled:false
		button btn_RemNT "Remove" width:50 enabled:false
	)
	
	function CheckNode scnObj =
	(
		if SuperClassOf scnObj == shape then
		(
			if (getUserProp scnObj "Length") == 0 then
			(
				if (substring scnObj.name 5 -1 != "_null") then
					scnObj.name = scnObj.name + "_null"
				append fndNulls scnObj.name
				append ptrNulls scnObj
				nullFounded += 1
			)
			labFnd.text = (nullFounded as string) + " nulltrack(s)"
			
		)
		return true
	)
		
	function RecursiveCheckNode node =
	(
		if (CheckNode node) == false then
			return false
			
		for child in node.children do
			RecursiveCheckNode child
	)
	
	function RemoveRef num =
	(
		if (num > 0) then
		(
			deleteItem fndNulls num
			deleteItem ptrNulls num
			deleteItem dlNTList.items num
			nullFounded -= 1
			labFnd.text = (nullFounded as string) + " nulltrack(s)"
		)
	)	
	
	on dlNTList selected i do
	(
		btn_FixNT.enabled = true
		btn_SelNT.enabled = true
		btn_RemNT.enabled = true
		dlNTList.caption = ("NullTrack          (" + ((curveLength ptrNulls[i]) as string) + " m)")
	)
	
	on btn_CheckNT pressed do
	(
		nullFounded = 0
		fndNulls = #()
		ptrNulls = #()
		clearSelection()
		for node in rootnode.children do
		(
			RecursiveCheckNode node
		)
		if nullFounded > 0 then
		(
			dlNTList.items = fndNulls
			dlNTList.enabled = true
			btn_SelNT.enabled = true
			btn_FixNT.enabled = true
			btn_RemNT.enabled = true
		)
		print ("Found " + (nullFounded as string) + " nulltrack(s)")
	)
	
	on btn_SelNT pressed do
	(
		if dlNTList.selection > 0 then
			select (ptrNulls[dlNTList.selection])
	)

	on btn_FixNT pressed do
	(
		if dlNTList.selection > 0 then
		(
			obj = (ptrNulls[dlNTList.selection])
			if (getUserProp obj "Length") != (curveLength obj) then
			(
				if (queryBox ("Track "+(obj.name)+ " has incorrect \"Length\" property value.  Do you want to fix it? ") title:"Incorrect Length value") then
				(
					setUserProp obj "Length" (curveLength obj)
					obj.name = (substring obj.name 1 (obj.name.count - 5))
				
					RemoveRef dlNTList.selection
					deselect obj
					print ("NullTrack fixed ("+(nullFounded as string)+" remaining)")
					dlNTList.selection = 0
					dlNTList.caption = "NullTrack"
					btn_FixNT.enabled = false
					btn_SelNT.enabled = false
					btn_RemNT.enabled = false
				)
			) 
		)
	)
	
	on btn_RemNT pressed do
	(
		if dlNTList.selection > 0 then
		(
			obj = (ptrNulls[dlNTList.selection])
			if (queryBox ("Czy chcesz usun znalezione NullTracki "+(obj.name)+" ?") title:"Usuwanie nulltrack'w") then
			(	
				delete obj
				
				RemoveRef dlNTList.selection
				print ("NullTrack removed ("+(nullFounded as string)+" remaining)")
				dlNTList.selection = 0
				dlNTList.caption = "NullTrack"
				btn_FixNT.enabled = false
				btn_SelNT.enabled = false
				btn_RemNT.enabled = false
			)
		)
	)
	
)