fn fixLength node = 
(
		l= curveLength node
		print l
		if (l>100) then
		(
			n= ceil (l/100)
			print n
			subdivideSegment node 1 1 (n-1)
			updateShape node
			for i=1 to n do
			(
				spl= copy node
				spl.name= node.name
				setUserPropBuffer spl (getUserPropBuffer node)
				j=(numKnots spl 1)
				while (j>=1) do
				(
					if (j!=i and j!=i+1) then
						deleteKnot spl 1 j
					j-= 1
				)
				spl.wireColor= (color 20 50 200)
				updateShape spl
			)
			delete node
			print "fixed"
		
		)

)

fn getPointDir viewPoint worldPoint gridPoint currentNode=
(
				box= (box2  (viewPoint+[5,5,5]) (viewPoint-[5,5,5]) )
				arr= (boxPickNode box)
				wpt= worldPoint
				
				n=0
				minDist= 10000
				minPt= gridPoint+[0,0,0.2]
				minDir= [0,1,0]
				for node in arr do
				(
					if (currentNode!=node) and (SuperClassOf node == shape) then
					(
						convertToSplineShape node
						for i=1 to (numSplines node) do
						(
							nk= (numKnots node i)
							
							pt= getKnotPoint node i 1
							wpt.z= pt.z
							dist= distance pt wpt
							if (dist<minDist) then
							(
								minPt= pt
								minDist= dist
								if ((getSegmentType node i 1)==#line) then
									minDir= pt - (getKnotPoint node i 2)
								else
									minDir= pt - (getOutVec node i 1)
								
							)

							pt= getKnotPoint node i nk
							wpt.z= pt.z
							dist= distance pt wpt
							if (dist<minDist) then
							(
								minPt= pt
								minDist= dist
								if ((getSegmentType node i (nk-1))==#line) then
									minDir= pt - (getKnotPoint node i (nk-1))
								else
									minDir= pt - (getInVec node i nk)
							)

						)
					)
				)
				minDir= (normalize minDir)
				#(minPt,minDir)
)

fn AddTrack minPt minDir type nodeName length direction radius totalangle minPt2 minDir2 =
(
	disableSceneRedraw()
				if (type==1) then
				(
					l= line name:nodeName pos:minPt
					addNewSpline l
					addKnot l 1 #smooth #line minPt
					addKnot l 1 #smooth #line (minPt+minDir*length)
					updateShape l
					track= l
				)
				else
				if (type==3) then
				(
					l= line name:nodeName pos:minPt
					len= (distance  minPt minPt2)/3
					addNewSpline l
					addKnot l 1 #bezier #curve minPt minPt (minPt+minDir*len)
					addKnot l 1 #bezier #curve minPt2 (minPt2+minDir2*len) minPt2
					updateShape l
					track= l
				)
				else
				(
					vec= normalize (cross z_axis minDir)
					if (direction==2) then 
						pt= minPt-vec*radius
					else
						pt= minPt+vec*radius
					dir= minDir
					dir.z=0
					dir= normalize dir
					if (dir.x!=0) then
						angle= atan (dir.y/dir.x)
					else
						if (dir.y>0) then
							angle= 90
						else
							angle= -90
					if (dir.x<0) then
						if (dir.y<0) then
							angle= angle-180
						else
							angle= 180+angle
					Format "angle: %\n" angle
					if (totalangle>0) then
						ang= totalangle*3
					else
						ang= (length*360*3)/(2*pi*radius)
					if (ang>270) then
						ang= 270
					if (direction==2) then 
					(
						ato= angle+90
						afrom= ato-ang
					)
					else
					(
						afrom= angle-90 
						ato= afrom+ang
					)
					
					if (afrom<0) then
					(
						afrom= afrom+360
					)
					if (ato<0) then
						ato= ato+360
					if (ato>360) then
						ato= ato-360
					print afrom
					print ato
					print radius
					a= arc name:nodeName pos:pt radius:radius from:afrom to:ato
					convertToSplineShape a
					if (direction==1) then 
					(
						deleteKnot a 1 (numKnots a 1)
						deleteKnot a 1 (numKnots a 1)
						updateShape a
					)
					else
					(
						deleteKnot a 1 1
						deleteKnot a 1 1
						reverse a 1
						updateShape a
						
					)
					track= a
					
				)
	enableSceneRedraw()
	
	return track
)


fn shapeFilt o = superClassOf o == Shape 

rollout CreateNormalRiver "Create River"
(
	editText eName "Name" text:"" 
	radioButtons rbType "Type" labels:#(#Line, #Arc, #Flex) align:#left
	radioButtons rbDirection "Direction" labels:#(#Left, #Right) enabled:false align:#left
	spinner spnRoll1 "Roll 1" range:[-45,45,0] align:#left
	spinner spnRoll2 "Roll 2" range:[-45,45,0] align:#left
	spinner spnLength "Length" range:[0,500,100] align:#left
	spinner spnRadius "Radius" range:[5,1000,50] enabled:false align:#left
	spinner spnAngle "Angle" range:[0,90,45] enabled:false align:#left

	editText eMaxdist "MaxDistance" text:"-1" 
	editText eMindist "MinDistance" text:"0" 
	editText eParam1 "TrackWidth" text:"15.0" 
	editText eParam2 "Friction" text:"0.5" 
	editText eParam3 "SoundDist" text:"100" 
	editText eParam4 "Quality" text:"5" 
	editText eParam5 "DamageFlag" text:"0" 
	editText eParam6 "Environment" text:"mountain" 
	editText eParam7 "Visibility" text:"vis" 
	editText eParam8 "Tex1" text:"RiverMnt1" 
	editText eParam9 "TexLength" text:"6.0" 
	editText eParam10 "Tex2" text:"RiverMnt1bank" 
	editText eParam11 "TexHeight" text:"0.5" 
	editText eParam12 "TexWidth" text:"0.5" 
	editText eParam13 "TexSlope" text:"2.0" 
	editText eParam14 "WaterVelocity" text:"1.0" 
	button btn1 "Create"
	
	tool CreateTrack
	( 
		local nodeName
		local Pt1,Dir1
		local tr
                local r1= spnRadius.value
		on mousePoint clickno do 
			if clickno != 2 then
			(
				if (eName.text=="") then
					nodeName= "none"
				else
					if (getNodeByName eName.text)==undefined then
						nodeName= eName.text
					else
						nodeName= uniqueName eName.text
				print clickno
				ptArr= (getPointDir viewPoint worldPoint gridPoint #undefined)
                                if (rbType.state==2) then
				(
				 if (rbDirection.state==2) then
				 (
  				   r1= -r1
                                 )
                                )
				else
				(
  				 r1= 0
				)

				if (rbType.state==3) then
				(
					Pt1= ptArr[1]
					Dir1= ptArr[2]
					tr= (AddTrack Pt1 Dir1 rbType.state (nodeName) spnLength.value rbDirection.state spnRadius.value spnAngle.value Pt1 Dir1 )
				)
				else
				(
					tr= (AddTrack ptArr[1] ptArr[2] rbType.state (nodeName) spnLength.value rbDirection.state spnRadius.value spnAngle.value [0,0,0] [0,0,0])
				)
				setUserProp tr "Type" "river"
				setUserProp tr "Length" (spnLength.value as string)
				setUserProp tr "Radius1" (r1 as string)
				setUserProp tr "Roll1" (spnRoll1.value as string)
				setUserProp tr "Roll2" (spnRoll2.value as string)
				setUserProp tr "MaxDist" eMaxdist.text
				setUserProp tr "MinDist" eMindist.text
				setUserProp tr "TrackWidth" eParam1.text
				setUserProp tr "Friction" eParam2.text
				setUserProp tr "SoundDist" eParam3.text
				setUserProp tr "Quality" eParam4.text
				setUserProp tr "DamageFlag" eParam5.text
				setUserProp tr "Environment" eParam6.text
				setUserProp tr "Visibility" eParam7.text
				setUserProp tr "Tex1" eParam8.text
				setUserProp tr "TexLength" eParam9.text
				setUserProp tr "Tex2" eParam10.text
				setUserProp tr "TexPar1" eParam11.text
				setUserProp tr "TexPar2" eParam12.text
				setUserProp tr "TexPar3" eParam13.text
				setUserProp tr "Velocity" eParam14.text

				tr.wireColor= (color 20 50 200)
				fixLength tr
			)
			else
				if (rbType.state==3) then
					#stop

		on mouseMove clickno do
		(
			if (rbType.state==3) then
			(
				ptArr= (getPointDir viewPoint worldPoint gridPoint tr)
				len= (distance Pt1 ptArr[1])/3
				setKnotPoint tr 1 2 ptArr[1]
				setInVec tr 1 2 (ptArr[1]+ptArr[2]*len)
				setOutVec tr 1 2 ptArr[1]
				setOutVec tr 1 1 (Pt1+Dir1*len)
				updateShape tr
			)
		)
	) 

	on rbType changed state do
	(
		case state of
		(
			1:
			(
				spnLength.enabled= true
				spnRadius.enabled= false
				spnAngle.enabled= false
				rbDirection.enabled= false
			)
			2:
			(
				spnLength.enabled= true
				spnRadius.enabled= true
				spnAngle.enabled= true
				rbDirection.enabled= true
			)
			3:
			(
				spnLength.enabled= false
				spnRadius.enabled= false
				spnAngle.enabled= false
				rbDirection.enabled= false
			)
		)
	)

	on btn1 pressed do
	(
		startTool CreateTrack
	)
)

