fn fixRLength node = 
(
		l= curveLength node
		print l
		if (l>100) then
		(
			n= ceil (l/100)
			print n
			subdivideSegment node 1 1 (n-1)
			updateShape node
			for i=1 to n do
			(
				spl= copy node
				spl.name= node.name
				setUserPropBuffer spl (getUserPropBuffer node)
				j=(numKnots spl 1)
				while (j>=1) do
				(
					if (j!=i and j!=i+1) then
						deleteKnot spl 1 j
					j-= 1
				)
				spl.wireColor= (color 128 50 50)
				updateShape spl
			)
			delete node
			print "fixed"
		
		)

)

fn getPointDir viewPoint worldPoint gridPoint currentNode=
(
				box= (box2  (viewPoint+[5,5,5]) (viewPoint-[5,5,5]) )
				arr= (boxPickNode box)
				wpt= worldPoint
				
				n=0
				minDist= 10000
				minPt= gridPoint+[0,0,0.2]
				minDir= [0,1,0]
				for node in arr do
				(
					if (currentNode!=node) and (SuperClassOf node == shape) then
					(
						convertToSplineShape node
						for i=1 to (numSplines node) do
						(
							nk= (numKnots node i)
							
							pt= getKnotPoint node i 1
							wpt.z= pt.z
							dist= distance pt wpt
							if (dist<minDist) then
							(
								minPt= pt
								minDist= dist
								if ((getSegmentType node i 1)==#line) then
									minDir= pt - (getKnotPoint node i 2)
								else
									minDir= pt - (getOutVec node i 1)
								
							)

							pt= getKnotPoint node i nk
							wpt.z= pt.z
							dist= distance pt wpt
							if (dist<minDist) then
							(
								minPt= pt
								minDist= dist
								if ((getSegmentType node i (nk-1))==#line) then
									minDir= pt - (getKnotPoint node i (nk-1))
								else
									minDir= pt - (getInVec node i nk)
							)

						)
					)
				)
				minDir= (normalize minDir)
				#(minPt,minDir)
)

fn AddTrack minPt minDir type nodeName length direction radius totalangle minPt2 minDir2 =
(
	disableSceneRedraw()
				if (type==1) then
				(
					l= line name:nodeName pos:minPt
					addNewSpline l
					addKnot l 1 #smooth #line minPt
					addKnot l 1 #smooth #line (minPt+minDir*length)
					updateShape l
					track= l
				)
				else
				if (type==3) then
				(
					l= line name:nodeName pos:minPt
					len= (distance  minPt minPt2)/3
					addNewSpline l
					addKnot l 1 #bezier #curve minPt minPt (minPt+minDir*len)
					addKnot l 1 #bezier #curve minPt2 (minPt2+minDir2*len) minPt2
					updateShape l
					track= l
				)
				else
				(
					vec= normalize (cross z_axis minDir)
					if (direction==2) then 
						pt= minPt-vec*radius
					else
						pt= minPt+vec*radius
					dir= minDir
					dir.z=0
					dir= normalize dir
					if (dir.x!=0) then
						angle= atan (dir.y/dir.x)
					else
						if (dir.y>0) then
							angle= 90
						else
							angle= -90
					if (dir.x<0) then
						if (dir.y<0) then
							angle= angle-180
						else
							angle= 180+angle
					Format "angle: %\n" angle
					if (totalangle>0) then
						ang= totalangle*3
					else
						ang= (length*360*3)/(2*pi*radius)
					if (ang>270) then
						ang= 270
					if (direction==2) then 
					(
						ato= angle+90
						afrom= ato-ang
					)
					else
					(
						afrom= angle-90 
						ato= afrom+ang
					)
					
					if (afrom<0) then
					(
						afrom= afrom+360
					)
					if (ato<0) then
						ato= ato+360
					if (ato>360) then
						ato= ato-360
					print afrom
					print ato
					print radius
					a= arc name:nodeName pos:pt radius:radius from:afrom to:ato
					convertToSplineShape a
					if (direction==1) then 
					(
						deleteKnot a 1 (numKnots a 1)
						deleteKnot a 1 (numKnots a 1)
						updateShape a
					)
					else
					(
						deleteKnot a 1 1
						deleteKnot a 1 1
						reverse a 1
						updateShape a
						
					)
					track= a
					
				)
	enableSceneRedraw()
	
	return track
)

fn shapeFilt o = superClassOf o == Shape 

rollout CreateNormalRoad "Create Road"
(
	editText eName "Nazwa" text:"" 
	radioButtons rbType "Typ" labels:#(#prosta, #luk, #Flex) align:#left across:2 width:120
	radioButtons rbDirection "Odchylenie" labels:#(#Lewo, #Prawo) enabled:false align:#left width:80
	spinner spnRoll1 "Roll 1" range:[-45,45,0] align:#left across:2
	spinner spnRoll2 "Roll 2" range:[-45,45,0] align:#left
	spinner spnLength "Dlugosc" range:[0,500,100] align:#left
	spinner spnRadius "Promien" range:[5,5000,50] enabled:false align:#left
	spinner spnAngle "Kat" range:[0,90,45] enabled:false align:#left
	editText eMaxdist "MaxDistance" text:"-1" across:3
	editText eMindist "MinDistance" text:"0" 
	editText eParam1 "Szer. drogi" text:"5.0" 
	editText eParam2 "Friction" text:"0.85" across:2
	editText eParam3 "SoundDist" text:"-1" 
	editText eParam4 "Quality" text:"15" across:2
	editText eParam5 "DamageFlag" text:"0" 
	--editText eParam6 "Otoczenie" text:"flat" 
	radioButtons rbEnvironment "Otoczenie" labels:#(#Plaskie, #Nadbrzeze, #Most, #Gory, #Kanion, #Tunel) align:#left columns:3
	editText eParam7 "Widocznocs" text:"vis" across:2
	editText eParam9 "Dl. tex" text:"6.0" width:80
	--editText eParam8 "Tex 1" text:"AsphaltDark1_DashedWhite.bmp" 
	--editText eParam10 "Tex 2" text:"AsphaltDark1_side1.tga" 
	dropdownlist eParam8 "Tex1" items:#("Asphalt1", "Asphalt1_DashedWhite", "Asphalt1_SolidWhite", "AsphaltDark1", "AsphaltDark1_DashedWhite", "AsphaltGray1", "AsphaltPlatform1","droga_polna" , "none") across:2
	dropdownlist eParam10 "Tex2" items:#("Asphalt1_side1", "Asphalt1_side2", "AsphaltDark1_side1", "AsphaltPlatform1_side", "grass" , "none")
	editText eParam11 "Wys. tex" text:"0.2" across:3
	editText eParam12 "Szer. tex" text:"0.2" 
	editText eParam13 "TexSlope" text:"0.5" 
	editText eEvent1 "Event1" text:""
	editText eEvent2 "Event2" text:""
	spinner spnVelocity "Szybkosc" range:[-1,300,-1] scale:1 type:#float align:#left
	button btn1 "Stworz"
	
	on CreateNormalRoad open do
 	(
	nr = getINISetting (scriptDirectory+"ustawienia.ini" ) "drogi" "Tex1"
	if nr != "" then eParam8.selection = (nr as integer)	
	else eParam8.selection = 1
	nr = getINISetting (scriptDirectory+"ustawienia.ini" ) "drogi" "Tex2"
	if nr != "" then eParam10.selection = (nr as integer)	
	else eParam10.selection = 1
	
	
	)	
	
	on eParam8 selected nr do 
	(
	setINISetting (scriptDirectory+"ustawienia.ini") "drogi" "Tex1" (nr as string)
	)
	
	on eParam10 selected nr do 
	(
	setINISetting (scriptDirectory+"ustawienia.ini") "drogi" "Tex2" (nr as string)
	)
	
	
	tool CreateTrack
	( 
		local nodeName
		local Pt1,Dir1
		local tr
                local r1= spnRadius.value
		on mousePoint clickno do 
			if clickno != 2 then
			(
				if (eName.text=="") then
					nodeName= "none"
				else
					if (getNodeByName eName.text)==undefined then
						nodeName= eName.text
					else
						nodeName= uniqueName eName.text
				print clickno
				ptArr= (getPointDir viewPoint worldPoint gridPoint #undefined)
                                if (rbType.state==2) then
				(
				 if (rbDirection.state==2) then
				 (
  				   r1= -r1
                                 )
                                )
				else
				(
  				 r1= 0
				)

				if (rbType.state==3) then
				(
					Pt1= ptArr[1]
					Dir1= ptArr[2]
					tr= (AddTrack Pt1 Dir1 rbType.state (nodeName) spnLength.value rbDirection.state spnRadius.value spnAngle.value Pt1 Dir1 )
				)
				else
				(
					tr= (AddTrack ptArr[1] ptArr[2] rbType.state (nodeName) spnLength.value rbDirection.state spnRadius.value spnAngle.value [0,0,0] [0,0,0])
				)
				setUserProp tr "Type" "road"
				setUserProp tr "Length" (spnLength.value as string)
				setUserProp tr "Radius1" (r1 as string)
				setUserProp tr "Roll1" (spnRoll1.value as string)
				setUserProp tr "Roll2" (spnRoll2.value as string)
				setUserProp tr "MaxDist" eMaxdist.text
				setUserProp tr "MinDist" eMindist.text
				setUserProp tr "TrackWidth" eParam1.text
				setUserProp tr "Friction" eParam2.text
				setUserProp tr "SoundDist" eParam3.text
				setUserProp tr "Quality" eParam4.text
				setUserProp tr "DamageFlag" eParam5.text
				case rbEnvironment.state of
				(
					1:
					(
				    	setUserProp tr "Environment" "Flat"
				   	)
					2:
					(
				    	setUserProp tr "Environment" "Bank"
				   	)
					3:
				   	(
				    	setUserProp tr "Environment" "Bridge"
				   	)
				  	4:
				   	(
				    	setUserProp tr "Environment" "Mountains"
				   	)
				  	5:
				   	(
				    	setUserProp tr "Environment" "Canyon"
				   	)
				  	6:
				   	(
				    	setUserProp tr "Environment" "Tunnel"
				   	)
				)				
				setUserProp tr "Visibility" eParam7.text
				setUserProp tr "Tex1" eParam8.text
				setUserProp tr "TexLength" eParam9.text
				setUserProp tr "Tex2" eParam10.text
				setUserProp tr "TexPar1" eParam11.text
				setUserProp tr "TexPar2" eParam12.text
				setUserProp tr "TexPar3" eParam13.text

				if (eEvent1.text!="") then
					setUserProp tr "Event1" eEvent1.text
				if (eEvent2.text!="") then
					setUserProp tr "Event2" eEvent2.text
				if (spnVelocity.value>=0) then
				(
					setUserProp tr "Velocity" (spnVelocity.value as string)
				)
				tr.wireColor= (color 128 50 50)
				fixRLength tr
			)
			else
				if (rbType.state==3) then
					#stop

		on mouseMove clickno do
		(
			if (rbType.state==3) then
			(
				ptArr= (getPointDir viewPoint worldPoint gridPoint tr)
				len= (distance Pt1 ptArr[1])/3
				setKnotPoint tr 1 2 ptArr[1]
				setInVec tr 1 2 (ptArr[1]+ptArr[2]*len)
				setOutVec tr 1 2 ptArr[1]
				setOutVec tr 1 1 (Pt1+Dir1*len)
				updateShape tr
			)
		)
	) 

	on rbType changed state do
	(
		case state of
		(
			1:
			(
				spnLength.enabled= true
				spnRadius.enabled= false
				spnAngle.enabled= false
				rbDirection.enabled= false
			)
			2:
			(
				spnLength.enabled= true
				spnRadius.enabled= true
				spnAngle.enabled= true
				rbDirection.enabled= true
			)
			3:
			(
				spnLength.enabled= false
				spnRadius.enabled= false
				spnAngle.enabled= false
				rbDirection.enabled= false
			)
		)
	)

	on btn0 picked obj do
	(
		createPods obj spnPods.value spnPodsH.value spnPodsB.value spnPodsWC.value spnPodsWB.value mbTrackMat.material spnTexLen.value
	)
	on btn1 pressed do
	(
		startTool CreateTrack
	)
)

