fn getTractionPointDir viewPoint worldPoint gridPoint currentNode=
(
	local minDir
	local minPt
	box= (box2  (viewPoint+[5,5,5]) (viewPoint-[5,5,5]) )
	arr= (boxPickNode box)
	wpt= worldPoint
	n=0
	minDist= 10000
	minPt= gridPoint+[0,0,5.8]
	minDir= [0,1,0]
	for node in arr do
	(
		if (currentNode!=node) and (SuperClassOf node == shape) then
			if ((getUserProp node "Type")=="traction") then
		  	(
				convertToSplineShape node
				for i=1 to (numSplines node) do
				(
					nk= (numKnots node i)				
					pt= getKnotPoint node i 1
					wpt.z= pt.z
					dist= distance pt wpt
					if (dist<minDist) then
					(
						minPt= pt
						minDist= dist
						if ((getSegmentType node i 1)==#line) then
							minDir= pt - (getKnotPoint node i 2)
						else
							minDir= pt - (getOutVec node i 1)					
					)
					pt= getKnotPoint node i nk
					wpt.z= pt.z
					dist= distance pt wpt
					if (dist<minDist) then
					(
						minPt= pt
						minDist= dist
						if ((getSegmentType node i (nk-1))==#line) then
							minDir= pt - (getKnotPoint node i (nk-1))
						else
							minDir= pt - (getInVec node i nk)
					)
				)
			)
	)
	minDir= (normalize minDir)
	#(minPt,minDir)
)


rollout CreateTraction "Create Traction"
(
	local tr
	local atemp
	local wireshift
	editText eName "PowerSupplyName" text:"pwr01" 
	radioButtons rbType "Placement method" labels:#(#Line, #Arc) align:#left
	radioButtons rbDirection "Arc Direction" labels:#(#Left, #Right) enabled:false align:#left
	spinner spnRoll1 "h1 [m]" range:[0,5,1.7] align:#left
	spinner spnRoll2 "h2 [m]" range:[0,5,1.7] align:#left
	spinner spnLength "Length [m]" range:[0.2,100,70] align:#left
	spinner spnRadius "Radius [m]" range:[20,2000,500] enabled:false align:#left
	spinner spnAngle "Angle [deg]" range:[0,30,5.7296] enabled:false align:#left
	spinner spnSlope "Slope/1000" range:[-50,50,0] align:#left

--	editText eMaxdist "MaxDistance" text:"-1" 
--	editText eMindist "MinDistance" text:"0" 
	editText eParam1 "Resistivity [ohm]" text:"0.01" 
	editText eParam2 "WireThickness [mm]" text:"3.0" 
	editText eParam3 "Hmin [m]" text:"0.4" 
	editText eParam4 "DeltaL [m]" text:"4.0" 
	editText eParam5 "DamageFlag" text:"1" 
	radioButtons rbMaterial "Material" labels:#(#Cu, #Al) align:#left
	editText eParam7 "Visibility" text:"vis" 
	editText eParam8 "Wires No" text:"3" 
	editText eParam9 "Wires Offset" text:"0.04" 
--	editText eEvent0 "Event0" text:""

	button btn1 "Create new"
	button btn1add "Add to previous" enabled:false

	spinner spnShift "Wire mnt. shift" range:[-0.5,0.5,0.2] align:#left
        editText eCSpnS "Current shift" text:"0.2" 
	editText ePole1 "Pole zigzag +" text:"tr/P-STB2-3K.inc;BetonRelief1" 
	editText ePole2 "Pole zigzag -" text:"tr/P-STB2-3D.inc;BetonRelief1" 
	editText ePoleL "Pole Left Arc" text:"tr/P-STB2-3K.inc;BetonRelief1" 
	editText ePoleR "Pole Right Arc" text:"tr/P-STB2-3D.inc;BetonRelief1" 
	colorPicker cp1 "Color" 
	button btnzigzag "Make ZigZag"

fn AddNewTraction minPt minDir type nodeName length direction radius totalangle trackslope oldtraction=
(
	local dir
	local vec
	disableSceneRedraw()
				minDir.z= 0
				if (type==1) then
				(
					if (atemp!=undefined) then
					( 
				    	if not (isDeleted atemp) then
						delete atemp
						atemp=undefined
				  	)					
                    if (oldtraction==undefined) then
                    ( 
				  		l= line name:nodeName pos:minPt
						addNewSpline l
						addKnot l 1 #smooth #line minPt
						addKnot l 1 #smooth #line (minPt+minDir*length+[0,0,trackslope*length/1000])
				  	)
					else
                    (
 				  		l= oldtraction
						print (addKnot l 1 #smooth #line (minPt+minDir*length+[0,0,trackslope*length/1000]))
					)
					l.wireColor= (color 210 70 30)
					updateShape l
				)
				else
				(
                   	if (oldtraction==undefined) then
						l= line name:nodeName pos:minPt	
					vec= normalize (cross z_axis minDir)
					if (direction==2) then 
						pt= minPt-vec*radius
					else
						pt= minPt+vec*radius
					dir= minDir
					dir.z=0
					dir= normalize dir
				 
					if (dir.x!=0) then
						angle= atan (dir.y/dir.x)
					else
						if (dir.y>0) then
							angle= 90
						else
							angle= -90
					if (dir.x<0) then
						if (dir.y<0) then
							angle= angle-180
						else
							angle= 180+angle
					Format "angle: %\n" angle
					if (totalangle>0) then
						ang= totalangle*3
					else
						ang= (length*180*3)/(pi*radius)
					if (ang>270) then
						ang= 270
					if (direction==2) then 
					(
						ato= angle+90
						afrom= ato-ang
					)
					else
					(
						afrom= angle-90 
						ato= afrom+ang
					)
					
					if (afrom<0) then
					(
						afrom= afrom+360
					)
					if (ato<0) then
						ato= ato+360
					if (ato>360) then
						ato= ato-360
					print afrom
					print ato
					print radius

					atemp= arc name:"deleteme" pos:pt radius:radius from:afrom to:ato
					convertToSplineShape atemp
					if (direction==1) then 
					(
						deleteKnot atemp 1 (numKnots atemp 1)
						deleteKnot atemp 1 (numKnots atemp 1)
						updateShape atemp
					)
					else
					(
						deleteKnot atemp 1 1
						deleteKnot atemp 1 1
						reverse atemp 1
						updateShape atemp
						
					)


					pt2= [0,0,0]
--				 	if (direction==2) then 
--						pt2= pt+radius*(cos totalangle)*vec+radius*(sin totalangle)*dir
--				 	else
--				 		pt2= pt-radius*(cos totalangle)*vec+radius*(sin totalangle)*dir
					pt2= getKnotPoint atemp 1 (numKnots atemp 1)
					pt2.z= minPt.z+trackslope*length/1000
--				 	print (cos totalangle)
--				 	print pt
					print pt2
					print dir
                    if (oldtraction==undefined) then
				  	(
						l= line name:nodeName pos:minPt	
						addNewSpline l
						addKnot l 1 #smooth #line minPt
						addKnot l 1 #smooth #line pt2
				  	)
				 	else
				  	(
 				  		l= oldtraction
						print (addKnot l 1 #smooth #line (pt2+[0,0,trackslope*length/1000]))
				  	)
				 	updateShape l
									
				)
	enableSceneRedraw()
	
	return l
)


	
	tool CreateNewTraction
	( 
		local nodeName
		local Pt1,Dir1
--		local tr
		on mousePoint clickno do 
			if clickno != 2 then
			(
				if (eName.text=="") then
					nodeName= "none"
				else
--					if (getNodeByName eName.text)==undefined then
						nodeName= eName.text
--					else
--						nodeName= uniqueName eName.text
				print clickno
				ptArr= (getTractionPointDir viewPoint worldPoint gridPoint #undefined)

				tr= (AddNewTraction ptArr[1] ptArr[2] rbType.state (nodeName) spnLength.value rbDirection.state spnRadius.value spnAngle.value spnSlope.value undefined)				
				setUserProp tr "Type" "traction"
				setUserProp tr "MaxDistance" "700"
				setUserProp tr "MinDistance" "0"
				setUserProp tr "h1" (spnRoll1.value as string)
				setUserProp tr "h2" (spnRoll2.value as string)
--				setUserProp tr "MaxDist" eMaxdist.text
--				setUserProp tr "MinDist" eMindist.text
				setUserProp tr "resistivity" eParam1.text
				setUserProp tr "wirethickness" eParam2.text
				setUserProp tr "hmin" eParam3.text
				setUserProp tr "deltal" eParam4.text
				setUserProp tr "damageflag" eParam5.text
				case rbMaterial.state of
				(
					1:
				   	(
				   		setUserProp tr "material" "Cu"
				   	)
				  	2:
				   	(
				    	setUserProp tr "material" "Al"
				   	)
				)				
				setUserProp tr "visibility" eParam7.text
				setUserProp tr "wires" eParam8.text
				setUserProp tr "wireoffset" eParam9.text
--				if (eEvent0.text!="") then
--					setUserProp tr "Event0" eEvent0.text
				tr.wireColor= (color 230 90 30)
--				fixLength tr
			)
	) 
--createnewtraction

	tool MakeZigzag
	( 
		local Dir
		local pt
		local vec
		on mousePoint clickno do 
		if clickno != 2 then
		(
			box= (box2  (viewPoint+[5,5,5]) (viewPoint-[5,5,5]) )
			arr= (boxPickNode box)
			wpt= worldPoint
			n=0
			minDist= 10000
			for node in arr do
			(
		   		if (SuperClassOf node == shape) then
			   		if ((getUserProp node "Type")=="traction") then
			    	(
--					node.wireColor= (color 180 80 0)
	            	node.wireColor= (cp1.color)
					convertToSplineShape node
					for i=1 to (numSplines node) do
				 	(
						nk= (numKnots node i)
						for j=2 to nk do
					 	(
							if ((getUserProp node (j as string))==undefined) then 
						 	(
								if (wireshift>0) then
							  		setUserProp node (j as string) ePole1.text
								else
							  		setUserProp node (j as string) ePole2.text
								pt= (getKnotPoint node i j)
								Dir= pt - (getKnotPoint node i (j-1))
								Dir.z=0
								vec= (cross Dir z_axis)
								vec= (normalize vec)
								vec= wireshift*vec
								pt= pt+vec
								setKnotPoint node i j pt 
								wireshift= -wireshift 
								eCSpnS.text = (wireshift as string)
						 	)					
					 	)					
				 	)
			    )
			 )
		)
	) 
--makezigzag


	fn AddTraction=
	( 
		local nodeName
		local Pt1,Dir1
		if (eName.text=="") then
			nodeName= "none"
		else
--			if (getNodeByName eName.text)==undefined then
				nodeName= eName.text
--			else
--				nodeName= uniqueName eName.text
--		ptArr= (getPointDir viewPoint worldPoint gridPoint #undefined)

		nk=0
		minPt= [0,0,5.8]
		minDir= [0,1,0]
		convertToSplineShape tr
		nk= (numKnots tr 1)
		print nk
		minPt= getKnotPoint tr 1 nk
		minPt2 = (getKnotPoint tr 1 (nk-1))
-- 		print atemp
		if (atemp==undefined) or (isDeleted atemp) then
			minDir= minPt - minPt2
		else
		(
			minDir= minPt - (getInVec atemp 1 (numKnots atemp 1))
   		   	Format "dir: % %\n" minDir.x minDir.y
	    	delete atemp
  		   	atemp=undefined
		)
		minDir= (normalize minDir)
		print minDir
		print minPt
		print minPt2

		newtr= (AddNewTraction minPt minDir rbType.state (nodeName) spnLength.value rbDirection.state spnRadius.value spnAngle.value spnSlope.value tr)	
		return newtr

	) 
--addtraction

	on rbType changed state do
	(
		case state of
		(
			1:
			(
				spnLength.value= 70.0
				spnRadius.enabled= false
				spnAngle.enabled= false
				rbDirection.enabled= false
				spnShift.enabled= true
--				spnSlope.enabled= true
			)
			2:
			(
				spnLength.value= spnRadius.value*spnAngle.value*pi/180
				spnRadius.enabled= true
				spnAngle.enabled= true
				rbDirection.enabled= true
				spnShift.enabled= false
--				spnSlope.enabled= false
				if atemp!=undefined then
					if not (isDelete atemp) then
				  	( 
				    	delete atemp
						atemp=undefined
				  	)
			)
		)
	)

	on btn1 pressed do
	(
--		wireshift= spnShift.value
		if (atemp!=undefined) then
		( 
		   	if not (isDeleted atemp) then 
			delete atemp
			atemp=undefined
		)
		startTool CreateNewTraction
		btn1add.enabled= true
	)
	on btn1add pressed do
	(
--		wireshift= spnShift.value
		tr = AddTraction()
		if (rbType.state==2) then
		(
			nk= (numKnots tr 1)
			case rbDirection.state of
		  	(
				1:
				(
					setUserProp tr (nk as string) ePoleL.text
				)
				2:
				(
					setUserProp tr (nk as string) ePoleR.text
				)
		   	)								
		)
	)
	on btnzigzag pressed do
	(
		wireshift= spnShift.value
		startTool MakeZigzag
	)
	on spnAngle changed value do
	     spnLength.value= spnRadius.value*spnAngle.value*pi/180
	on spnRadius changed value do
	     spnLength.value= spnRadius.value*spnAngle.value*pi/180
	on spnLength changed value do
         if (rbType.state==2) then
	     	spnAngle.value= spnLength.value*180/(spnRadius.value*pi)
)
---createtraction

