-------------------------------------------------------------------------------------
-- DelanuayExp.ms
-- Poprawka ISDR 01.05.2008
-------------------------------------------------------------------------------------

	rollout DelExport "Delanuay mesh"
	(
		local ostream, tabs = ""
		local pts= #()
		local edges= #()
		local numPts= 0
	
	
		button btn_export "Make" width:100 
	
	
	
		-------------------------------------------------------------------------------------
		function importDel =
		(
			fname = scriptDirectory+"tmp.1.node"
			ostream = OpenFile fname
			if ostream == undefined then
			(
				MessageBox "Couldn't open file for reading ! tmp.1.node"
				return undefined
			)
			if ostream != undefined then
			(
				numPts= (readValue ostream)
				Format "%\n" numPts
				pts= #()
				skipToNextLine ostream
				for i=1 to numPts do
				(
					n= (readValue ostream)
					x= (readValue ostream)
					y= (readValue ostream)
					z= (readValue ostream)
					b= (readValue ostream)
					append pts [x,y,z]
				)
				Close ostream
			)
			
			fname = scriptDirectory+"tmp.1.ele"
			ostream = OpenFile fname
			if ostream == undefined then
			(
				MessageBox "Couldn't open file for reading ! tmp.1.ele"
				return undefined
			)
			if ostream != undefined then
			(
				numTris= (readValue ostream)
				tris= #()
				skipToNextLine ostream
				for i=1 to numTris do
				(
					n= (readValue ostream)
					x= (readValue ostream)
					y= (readValue ostream)
					z= (readValue ostream)
					append tris [x,y,z]
				)
				Close ostream
			)

			Format "pts: %  tris: %\n" pts.count tris.count
			mesh vertices:pts faces:tris
		)
		
		-------------------------------------------------------------------------------------
		function ExportPoint ptObj =
		(
			
			Format ("Exporting point: % \n") ptObj.name
			if (ptObj.parent!=undefined) then
				TM= ptObj.transform * (inverse ptObj.parent.transform)
			else
				TM= ptObj.transform
			
			(append pts [TM.translation.x TM.translation.y TM.translation.z])
			numPts= numPts+1
			
		
		)
		-------------------------------------------------------------------------------------
		function ExportSpline splObj =
		(
			Format ("Exporting spline: % \n") splObj.name
			offset= (getUserProp splObj "TexPar1")
			if offset==undefined then
				offset= 0
			for i = 1 to (numSplines splObj) do
			(
				for j = 1 to ((numKnots splObj i) - 1) do
				(
					pt= (getKnotPoint splObj i j) + [0,0,-offset]
					append pts pt
					numPts= numPts+1
					append edges [numPts,numPts+1]
				)
				pt= (getKnotPoint splObj i (numKnots splObj i)) + [0,0,-offset]
				append pts pt
				numPts= numPts+1
				if (isClosed splObj i) then
					append edges [numPts,numPts-(numKnots splObj i)+1]
			)
		)


		
		-------------------------------------------------------------------------------------
		function ExportNode node =
		(
--			if SuperClassOf node == Helper and ClassOf node == Point then
--				ExportPoint node
			if SuperClassOf node == shape then
			(
                            if  (getUserProp node "Type")==undefined then
					ExportSpline node
				else
				if  ((getUserProp node "Type")=="river") then
					ExportSpline node
				else	
                                if  ((getUserProp node "Type")=="road") or ((getUserProp node "Type")=="normal") then
					if  ((getUserProp node "Environment")=="flat") or  ((getUserProp node "Environment")=="Flat") then
		 				ExportSpline node
			)
			return true
		)
	
		-------------------------------------------------------------------------------------
		function RecursiveExportNode node =
		(
			if (ExportNode node) == false then
				return false
	
			for child in node.children do
				RecursiveExportNode child
				
		)
	
		-------------------------------------------------------------------------------------
		function ExportDel =
		(
			
		pts= #()
		edges= #()
		numPts= 0
		
--			if cb_exportSelOnly.checked then
--			(
				for node in selection do
					ExportNode node
--			)
--			else
--			(
--				for node in rootnode.children do
--					RecursiveExportNode node
--			)
			
			Format ("% 2 1 0 \n") pts.count to:ostream
			for i = 1 to (pts.count) do
			(
				Format ("%  % % % \n") i pts[i].x pts[i].y pts[i].z to:ostream
			)
			Format ("% 0 \n") edges.count to:ostream
			for i = 1 to (edges.count) do
			(
				Format ("%  % % \n") i (edges[i].x as Integer) (edges[i].y as Integer) to:ostream
			)
			Format ("0 \n") to:ostream

			
		)
	
		-------------------------------------------------------------------------------------
		function GetSaveFileStream =
		(

--			scriptDirectory= (getDir #scripts)+"\\EU07\\"
--			fname = GetSaveFileName types:"Poly files (*.poly)|*.poly|All Files(*.*)|*.*|"
			fname = scriptDirectory+"tmp.poly"
			if fname == undefined then
				return undefined
	
			ostream = CreateFile fname
			if ostream == undefined then
			(
				MessageBox "Couldn't open file for writing ! tmp.poly"
				return undefined
			)
	
			return ostream
		)
	
	
		-------------------------------------------------------------------------------------
		on btn_export pressed do
		(
			scriptDirectory= (getDir #scripts)+"\\EU07\\"
			ostream = GetSaveFileStream()
			if ostream != undefined then
			(
				
				ExportDel ()

				Close ostream
				if (numPts>0) then
				(
					
					fname= scriptDirectory+"tri.bat"
					
					ostream = CreateFile fname
					tokens= filterString scriptDirectory "\\"
					Format "%\n" tokens[1] to:ostream
					Format "cd %\n" scriptDirectory to:ostream
					Format "call triangulate.bat\n" to:ostream
					Close ostream
	
					
					command= "\""+scriptDirectory+"tri.bat"+"\""
					DOSCommand command


					importDel()				

					command= "del "+"\""+scriptDirectory+"tri.bat"+"\""
					DOSCommand command

					command= "del "+"\""+scriptDirectory+"tmp.poly"+"\""
					DOSCommand command

					command= "del "+"\""+scriptDirectory+"tmp.1.poly"+"\""
					DOSCommand command

					command= "del "+"\""+scriptDirectory+"tmp.1.ele"+"\""
					DOSCommand command

					command= "del "+"\""+scriptDirectory+"tmp.1.node"+"\""
					DOSCommand command



				)
			)
		)
		
	
	) -- End DelExport 
	
