-------------------------------------------------------------------------------------
-- DelanuayExp.ms
-------------------------------------------------------------------------------------

		tabs = ""
		pts= #()
		holes= #()
		attribs= #()
		edges= #()
		numPts= 0
		numHoles= 0
		numAttribs= 0
		totalTriPts= 0
		numMeshes= 0
		
		ostream= undefined
		triostream= undefined
	
		-------------------------------------------------------------------------------------
--		function GetSaveFileStream =
--		(

--			scriptDirectory= (getDir #scripts)+"\\EU07\\"
			fname = GetSaveFileName types:"Poly files (*.poly)|*.poly|All Files(*.*)|*.*|"
--			fname = scriptDirectory+"tmp.poly"
			if fname == undefined then
				return undefined
	
			ostream = CreateFile fname
			if ostream == undefined then
			(
				MessageBox "Couldn't open file for writing !"
--				return undefined
			)
			else
			(
				fname= fname+"tri"
				triostream  = CreateFile fname
				if triostream == undefined then
				(
					MessageBox "Couldn't open file for writing !"
				)

			)
	
--			return ostream
--		)
	
--		ostream = GetSaveFileStream()
	
		-------------------------------------------------------------------------------------
		function importDel =
		(
			fname = scriptDirectory+"tmp.1.node"
			ostream = OpenFile fname
			if ostream == undefined then
			(
				MessageBox "Couldn't open file for reading !"
				return undefined
			)
			if ostream != undefined then
			(
				numPts= (readValue ostream)
				Format "%\n" numPts
				pts= #()
				skipToNextLine ostream
				for i=1 to numPts do
				(
					n= (readValue ostream)
					x= (readValue ostream)
					y= (readValue ostream)
					z= (readValue ostream)
					b= (readValue ostream)
					append pts [x,y,z]
				)
				Close ostream
			)
			
			fname = scriptDirectory+"tmp.1.ele"
			ostream = OpenFile fname
			if ostream == undefined then
			(
				MessageBox "Couldn't open file for reading !"
				return undefined
			)
			if ostream != undefined then
			(
				numTris= (readValue ostream)
				tris= #()
				skipToNextLine ostream
				for i=1 to numTris do
				(
					n= (readValue ostream)
					x= (readValue ostream)
					y= (readValue ostream)
					z= (readValue ostream)
					append tris [x,y,z]
				)
				Close ostream
			)
			Format "pts: %  tris: %\n" pts.count tris.count
			mesh vertices:pts faces:tris
		)

		function edgeVerts theObj theEdge = 
		( 
			if not (classof theObj == Editable_mesh or 
			classof theObj == triMesh) do return undefined 
			if theEdge < 1 or theEdge > (theObj.numfaces*3) do return undefined 
			local theFace = ((theEdge-1)/3)+1 
			local theVerts = getFace theObj theFace 
			case ((mod (theEdge-1) 3) as integer) of 
			( 
				0: point2 theVerts.x theVerts.y 
				1: point2 theVerts.y theVerts.z 
				2: point2 theVerts.z theVerts.x 
			) 
		) 


		-------------------------------------------------------------------------------------
		function ExportMesh meshObj =
		(
			if ((getUserProp meshObj"hole")==1) then
			(
				openEdges= meshop.getOpenEdges meshObj
				for i = 1 to (meshObj.numFaces*3) do
				(
					if openEdges[i] then
					(
						local vrts= edgeVerts meshObj i
						vrt1= (GetVert meshObj vrts.x)
						vrt2= (GetVert meshObj vrts.y)
						append pts vrt1
						append pts vrt2
						numPts= numPts+2
						append edges [numPts-1,numPts]
					)
				)
			
			
			
				if (meshObj.parent!=undefined) then
					TM= meshObj.transform * (inverse meshObj.parent.transform)
				else
					TM= meshObj.transform
	
				append holes TM.translation
				numHoles= numHoles+1
			)

			
			bHasMap= false;
			bHasMaterial= false;
			texture= "none";
			Format ("\n") to:triostream
			if (meshObj.material!=undefined) then
			(
				if ((meshObj.material.mapEnables[2]) and (meshObj.material.maps[2]!=undefined)) then
				(
					texture= filenameFromPath meshObj.material.maps[2].filename
-- getFilenameFile meshObj.material.maps[2].filename;
					bHasMap= true;
					Format ("texture: %\n") texture to:triostream
					
				)
				else
				(
					Format ("color: % % % 1\n") (meshObj.material.diffuse.r/255) (meshObj.material.diffuse.g/255) (meshObj.material.diffuse.b/255) to:triostream
				)
				bHasMaterial= true;
				
			)
			else
			(
				Format ("color: % % % 1\n") (meshObj.wireColor.r/255) (meshObj.wireColor.g/255) (meshObj.wireColor.b/255) to:triostream
			)
			if ((getUserProp meshObj"alpha_test")==1) then
				Format ("alpha_test\n") texture to:triostream
			else if ((getUserProp meshObj"alpha_blend")==1) then
				Format ("alpha_blend\n") texture to:triostream
			else
				Format ("opaque\n") texture to:triostream
			update meshObj true true true
			if (meshObj.numFaces) > 0 then
			(
--				if (bHasMap==true) then
--				(
				totalTriPts= totalTriPts+meshObj.numFaces*3
				numMeshes= numMeshes+1;
				Format ("%\n") (meshObj.numFaces*3) to:triostream
				for i = 1 to (meshObj.numFaces) do
				(
					vrt= getVert meshObj (GetFace meshObj i).x
					norm= getNormal meshObj (GetFace meshObj i).x
					Format ("% % %  ") vrt.x vrt.y vrt.z to:triostream
					Format ("% % %  ") norm.x norm.y norm.z to:triostream
					if (bHasMap) then
					(
						tvrt= getTVert meshObj (GetTVFace meshObj i).x
						Format ("% %\n") tvrt.x tvrt.y to:triostream
					)
					else
						Format ("\n") to:triostream

					vrt= getVert meshObj (GetFace meshObj i).y
					norm= getNormal meshObj (GetFace meshObj i).y
					Format ("% % %  ") vrt.x vrt.y vrt.z to:triostream
					Format ("% % %  ") norm.x norm.y norm.z to:triostream
					if (bHasMap) then
					(
						tvrt= getTVert meshObj (GetTVFace meshObj i).y
						Format ("% %\n") tvrt.x tvrt.y to:triostream
					)
					else
						Format ("\n") to:triostream

					vrt= getVert meshObj (GetFace meshObj i).z
					norm= getNormal meshObj (GetFace meshObj i).z
					Format ("% % %  ") vrt.x vrt.y vrt.z to:triostream
					Format ("% % %  ") norm.x norm.y norm.z to:triostream
					if (bHasMap) then
					(
						tvrt= getTVert meshObj (GetTVFace meshObj i).z
						Format ("% %\n") tvrt.x tvrt.y to:triostream
					)
					else
						Format ("\n") to:triostream
				)
			)
		)
	
		-------------------------------------------------------------------------------------
		function ExportPoint ptObj =
		(
			
			Format ("Exporting point: % \n") ptObj.name
			if (ptObj.parent!=undefined) then
				TM= ptObj.transform * (inverse ptObj.parent.transform)
			else
				TM= ptObj.transform
			
			append holes TM.translation
			numHoles= numHoles+1
		)
	
		-------------------------------------------------------------------------------------
		function ExportDummy dmObj =
		(
			
			Format ("Exporting dummy: % \n") dmObj.name
			if (dmObj.parent!=undefined) then
				TM= dmObj.transform * (inverse dmObj.parent.transform)
			else
				TM= dmObj.transform
			
			append attribs TM.translation
--			setUserProp dmObj "attrib" 1
			attribs[attribs.count].z= (getUserProp dmObj "attrib")
			numAttribs= numAttribs+1
		)

		-------------------------------------------------------------------------------------
		function ExportSpline splObj =
		(
			Format ("Exporting spline: % \n") splObj.name
			offset= (getUserProp splObj "TexPar1")
			if offset==undefined then
				offset= 0
			for i = 1 to (numSplines splObj) do
			(
				for j = 1 to ((numKnots splObj i) - 1) do
				(
					pt= (getKnotPoint splObj i j) + [0,0,-offset]
					append pts pt
					numPts= numPts+1
					append edges [numPts,numPts+1]
				)
				pt= (getKnotPoint splObj i (numKnots splObj i)) + [0,0,-offset]
				append pts pt
				numPts= numPts+1
				if (isClosed splObj i) then
					append edges [numPts,numPts-(numKnots splObj i)+1]
			)
		)


		
		-------------------------------------------------------------------------------------
		function ExportNode node =
		(
			if SuperClassOf node == Helper and ClassOf node == Point then
				ExportPoint node
			if SuperClassOf node == Helper and ClassOf node == Dummy then
				ExportDummy node
			if (SuperClassOf node == GeometryClass) then
			(
				convertToMesh node
				if (ClassOf node == Editable_mesh) then
					ExportMesh node
			)
			if SuperClassOf node == shape then
			(
                            if  (getUserProp node "Type")==undefined then
					ExportSpline node
				else
				if ((getUserProp node "Type")=="road") or ((getUserProp node "Type")=="river") then
					ExportSpline node
				else	
                                if  ((getUserProp node "Type")=="normal") then
					if  (getUserProp node "Environment")=="flat" then
		 				ExportSpline node
			)
			return true
		)
	
		-------------------------------------------------------------------------------------
		function RecursiveExportNode node =
		(
			if (ExportNode node) == false then
				return false
	
			for child in node.children do
				RecursiveExportNode child
				
		)
	
		-------------------------------------------------------------------------------------
		function ExportDel =
		(
			
		pts= #()
		edges= #()
		numPts= 0
		
--			if cb_exportSelOnly.checked then
--			(
				for node in selection do
					ExportNode node
--			)
--			else
--			(
--				for node in rootnode.children do
--					RecursiveExportNode node
--			)
			seek triostream 0
			Format ("% %\n") totalTriPts numMeshes to:triostream
				
				
			
			Format ("% 2 1 0 \n") pts.count to:ostream
			for i = 1 to (pts.count) do
			(
				Format ("%  % % % \n") i pts[i].x pts[i].y pts[i].z to:ostream
			)
			Format ("% 0 \n") edges.count to:ostream
			for i = 1 to (edges.count) do
			(
				Format ("%  % % \n") i (edges[i].x as Integer) (edges[i].y as Integer) to:ostream
			)
			Format ("% \n") holes.count to:ostream
			for i = 1 to (holes.count) do
			(
				Format ("%  % % \n") i holes[i].x holes[i].y to:ostream
			)
			Format ("% \n") attribs.count to:ostream
			for i = 1 to (attribs.count) do
			(
				Format ("%  % % %\n") i attribs[i].x attribs[i].y attribs[i].z to:ostream
			)

			
		)
	
	
		if ostream != undefined then
		(
			Format ("                                                   ") to:triostream
			ExportDel ()
			close ostream
			close triostream
		)
		
	
